
#ifndef DOTNETSTL_INCL_H_DOTNETSTL
# include <dotnetstl.h>
#endif /* !DOTNETSTL_INCL_H_DOTNETSTL */
#ifndef DOTNETSTL_INCL_DOTNETSTL_HPP_STRING_ACCESSOR
# include <dotnetstl/cstring_accessor.hpp>
#endif /* !DOTNETSTL_INCL_DOTNETSTL_HPP_STRING_ACCESSOR */

namespace stlsoft
{
	namespace dotnetstl_project
	{
		namespace impl
		{
			typedef c_string_accessor<char>		accessor_a_t;
			typedef c_string_accessor<wchar_t>	accessor_w_t;
#ifdef UNICODE
			typedef accessor_w_t				accessor_t_t;
#else /* ? UNICODE */
			typedef accessor_a_t				accessor_t_t;
#endif /* UNICODE */

		} // namespace impl


		inline size_t c_str_len(System::String const *s)
		{
			if(NULL == s)
			{
				return 0;
			}
			else
			{
				System::String	*s_	=	const_cast<System::String*>(s);

				return static_cast<size_t>(s_->get_Length());
			}
		}

		inline impl::accessor_a_t c_str_ptr_a(System::String const *s)
		{
			return impl::accessor_a_t(s);
		}

		inline impl::accessor_w_t c_str_ptr_w(System::String const *s)
		{
			return impl::accessor_w_t(s);
		}

		inline impl::accessor_t_t c_str_ptr(System::String const *s)
		{
			return impl::accessor_t_t(s);
		}

		inline impl::accessor_a_t c_str_data_a(System::String const *s)
		{
			return c_str_ptr_a(s);
		}

		inline impl::accessor_w_t c_str_data_w(System::String const *s)
		{
			return c_str_ptr_w(s);
		}

		inline impl::accessor_t_t c_str_data(System::String const *s)
		{
			return c_str_ptr(s);
		}



	}

	using dotnetstl_project::c_str_len;
	using dotnetstl_project::c_str_ptr_a;
	using dotnetstl_project::c_str_ptr_w;
	using dotnetstl_project::c_str_ptr;
	using dotnetstl_project::c_str_data_a;
	using dotnetstl_project::c_str_data_w;
	using dotnetstl_project::c_str_data;
}
