
#if !defined(STLSOFT_INCL_STLSOFT_HPP_STRING_ACCESS)
# error This file cannot be directly included, and should only be included within stlsoft/string_access.hpp
#endif /* !STLSOFT_INCL_STLSOFT_HPP_STRING_ACCESS */

#if !defined(STLSOFT_UNITTEST)
# error This file cannot be included when not unit-testing STLSoft
#endif /* !STLSOFT_UNITTEST */

namespace unittest
{
    namespace
    {
        ss_bool_t test_stlsoft_string_access(unittest_reporter *r)
        {
            ss_bool_t               bSuccess    =   true;

            unittest_initialiser    init(r, "STLSoft", "string_access", __FILE__);

            ss_char_a_t const   *s1 =   "String #1";

            if(c_str_ptr(s1) != s1)
            {
                r->report("c_str_ptr(char*) failed", __LINE__);
                bSuccess = false;
            }

            ss_char_a_t const   *s2 =   c_str_ptr(static_cast<ss_char_a_t*>(NULL));

            if(*s2 != '\0')
            {
                r->report("c_str_ptr(NULL) failed", __LINE__);
                bSuccess = false;
            }

            if(c_str_ptr_null(static_cast<ss_char_a_t*>(NULL)) != NULL)
            {
                r->report("c_str_ptr_null(NULL) failed", __LINE__);
                bSuccess = false;
            }

            return bSuccess;
        }

        unittest_registrar    unittest_stlsoft_string_access(test_stlsoft_string_access);
    } // anonymous namespace

} // namespace unittest

